diff --git a/src/or/policies.c b/src/or/policies.c
index 6738b48..b22164d 100644
--- a/src/or/policies.c
+++ b/src/or/policies.c
@@ -237,18 +237,6 @@ addr_policy_permits_tor_addr(const tor_addr_t *addr, uint16_t port,
   }
 }
 
-/** Return true iff <b> policy</b> (possibly NULL) will allow a connection to
- * <b>addr</b>:<b>port</b>.  <b>addr</b> is an IPv4 address given in host
- * order. */
-/* XXXX deprecate when possible. */
-static int
-addr_policy_permits_address(uint32_t addr, uint16_t port,
-                            smartlist_t *policy)
-{
-  tor_addr_t a;
-  tor_addr_from_ipv4h(&a, addr);
-  return addr_policy_permits_tor_addr(&a, port, policy);
-}
 
 /** Return true iff we think our firewall will let us make an OR connection to
  * addr:port. */
@@ -265,9 +253,7 @@ int
 fascist_firewall_allows_or(const routerinfo_t *ri)
 {
   /* XXXX proposal 118 */
-  tor_addr_t addr;
-  tor_addr_from_ipv4h(&addr, ri->addr);
-  return fascist_firewall_allows_address_or(&addr, ri->or_port);
+  return fascist_firewall_allows_address_or(&ri->addr, ri->or_port);
 }
 
 /** Return true iff we think our firewall will let us make an OR connection to
@@ -278,9 +264,7 @@ fascist_firewall_allows_node(const node_t *node)
   if (node->ri) {
     return fascist_firewall_allows_or(node->ri);
   } else if (node->rs) {
-    tor_addr_t addr;
-    tor_addr_from_ipv4h(&addr, node->rs->addr);
-    return fascist_firewall_allows_address_or(&addr, node->rs->or_port);
+    return fascist_firewall_allows_address_or(&node->rs->addr, node->rs->or_port);
   } else {
     return 1;
   }
@@ -317,36 +301,36 @@ socks_policy_permits_address(const tor_addr_t *addr)
  * directory, based on <b>authdir_reject_policy</b>. Else return 0.
  */
 int
-authdir_policy_permits_address(uint32_t addr, uint16_t port)
+authdir_policy_permits_address(const tor_addr_t *addr, uint16_t port)
 {
-  return addr_policy_permits_address(addr, port, authdir_reject_policy);
+  return addr_policy_permits_tor_addr(addr, port, authdir_reject_policy);
 }
 
 /** Return 1 if <b>addr</b>:<b>port</b> is considered valid in our
  * directory, based on <b>authdir_invalid_policy</b>. Else return 0.
  */
 int
-authdir_policy_valid_address(uint32_t addr, uint16_t port)
+authdir_policy_valid_address(const tor_addr_t *addr, uint16_t port)
 {
-  return addr_policy_permits_address(addr, port, authdir_invalid_policy);
+  return addr_policy_permits_tor_addr(addr, port, authdir_invalid_policy);
 }
 
 /** Return 1 if <b>addr</b>:<b>port</b> should be marked as a bad dir,
  * based on <b>authdir_baddir_policy</b>. Else return 0.
  */
 int
-authdir_policy_baddir_address(uint32_t addr, uint16_t port)
+authdir_policy_baddir_address(const tor_addr_t *addr, uint16_t port)
 {
-  return ! addr_policy_permits_address(addr, port, authdir_baddir_policy);
+  return ! addr_policy_permits_tor_addr(addr, port, authdir_baddir_policy);
 }
 
 /** Return 1 if <b>addr</b>:<b>port</b> should be marked as a bad exit,
  * based on <b>authdir_badexit_policy</b>. Else return 0.
  */
 int
-authdir_policy_badexit_address(uint32_t addr, uint16_t port)
+authdir_policy_badexit_address(const tor_addr_t *addr, uint16_t port)
 {
-  return ! addr_policy_permits_address(addr, port, authdir_badexit_policy);
+  return ! addr_policy_permits_tor_addr(addr, port, authdir_badexit_policy);
 }
 
 #define REJECT(arg) \
@@ -474,7 +458,7 @@ cmp_single_addr_policy(addr_policy_t *a, addr_policy_t *b)
     return r;
   if ((r=((int)a->is_private - (int)b->is_private)))
     return r;
-  if ((r=tor_addr_compare(&a->addr, &b->addr, CMP_EXACT)))
+  if ((r=tor_addr_cmp(&a->addr, &b->addr)))
     return r;
   if ((r=((int)a->maskbits - (int)b->maskbits)))
     return r;
@@ -570,18 +554,6 @@ addr_policy_get_canonical_entry(addr_policy_t *e)
   return found->policy;
 }
 
-/** As compare_tor_addr_to_addr_policy, but instead of a tor_addr_t, takes
- * in host order. */
-addr_policy_result_t
-compare_addr_to_addr_policy(uint32_t addr, uint16_t port,
-                            const smartlist_t *policy)
-{
-  /*XXXX deprecate this function when possible. */
-  tor_addr_t a;
-  tor_addr_from_ipv4h(&a, addr);
-  return compare_tor_addr_to_addr_policy(&a, port, policy);
-}
-
 /** Helper for compare_tor_addr_to_addr_policy.  Implements the case where
  * addr and port are both known. */
 static addr_policy_result_t
@@ -701,7 +673,7 @@ compare_tor_addr_to_addr_policy(const tor_addr_t *addr, uint16_t port,
   if (!policy) {
     /* no policy? accept all. */
     return ADDR_POLICY_ACCEPTED;
-  } else if (tor_addr_is_null(addr)) {
+  } else if (!addr || tor_addr_is_null(addr)) {
     tor_assert(port != 0);
     return compare_unknown_tor_addr_to_addr_policy(port, policy);
   } else if (port == 0) {
@@ -902,7 +874,7 @@ exit_policy_is_general_exit_helper(smartlist_t *policy, int port)
   memset(subnet_status, 0, sizeof(subnet_status));
   SMARTLIST_FOREACH(policy, addr_policy_t *, p, {
     if (tor_addr_family(&p->addr) != AF_INET)
-      continue; /* IPv4 only for now */
+      continue; /* IPv4 only for now (XXX-IPv6 TODO) */
     if (p->prt_min > port || p->prt_max < port)
       continue; /* Doesn't cover our port. */
     mask = 0;
@@ -984,7 +956,7 @@ policy_write_item(char *buf, size_t buflen, addr_policy_t *policy,
   const int is_accept = policy->policy_type == ADDR_POLICY_ACCEPT;
   const int is_ip6 = tor_addr_family(&policy->addr) == AF_INET6;
 
-  tor_addr_to_str(addrbuf, &policy->addr, sizeof(addrbuf), 1);
+  tor_addr_to_str(&policy->addr, addrbuf, sizeof(addrbuf), 1);
 
   /* write accept/reject 1.2.3.4 */
   if (policy->is_private)
@@ -1179,7 +1151,7 @@ policy_summary_add_item(smartlist_t *summary, addr_policy_t *p)
                                   &maskbits, NULL, NULL)<0) {
          tor_assert(0);
        }
-       if (tor_addr_compare(&p->addr, &addr, CMP_EXACT) == 0 &&
+       if (tor_addr_eq(&p->addr, &addr) &&
            p->maskbits == maskbits) {
          is_private = 1;
          break;
@@ -1471,17 +1443,6 @@ short_policy_is_reject_star(const short_policy_t *policy)
  * <b>node</b>.  See compare_tor_addr_to_addr_policy for details on addr/port
  * interpretation. */
 addr_policy_result_t
-compare_addr_to_node_policy(uint32_t addr, uint16_t port, const node_t *node)
-{
-  tor_addr_t a;
-  tor_addr_from_ipv4h(&a, addr);
-  return compare_tor_addr_to_node_policy(&a, port, node);
-}
-
-/** Decides whether addr:port is probably or definitely accepted or rejcted by
- * <b>node</b>.  See compare_tor_addr_to_addr_policy for details on addr/port
- * interpretation. */
-addr_policy_result_t
 compare_tor_addr_to_node_policy(const tor_addr_t *addr, uint16_t port,
                                 const node_t *node)
 {
diff --git a/src/or/policies.h b/src/or/policies.h
index ee1162c..d91e1ec 100644
--- a/src/or/policies.h
+++ b/src/or/policies.h
@@ -24,10 +24,10 @@ int fascist_firewall_allows_node(const node_t *node);
 int fascist_firewall_allows_address_dir(const tor_addr_t *addr, uint16_t port);
 int dir_policy_permits_address(const tor_addr_t *addr);
 int socks_policy_permits_address(const tor_addr_t *addr);
-int authdir_policy_permits_address(uint32_t addr, uint16_t port);
-int authdir_policy_valid_address(uint32_t addr, uint16_t port);
-int authdir_policy_baddir_address(uint32_t addr, uint16_t port);
-int authdir_policy_badexit_address(uint32_t addr, uint16_t port);
+int authdir_policy_permits_address(const tor_addr_t *addr, uint16_t port);
+int authdir_policy_valid_address(const tor_addr_t *addr, uint16_t port);
+int authdir_policy_baddir_address(const tor_addr_t *addr, uint16_t port);
+int authdir_policy_badexit_address(const tor_addr_t *addr, uint16_t port);
 
 int validate_addr_policies(or_options_t *options, char **msg);
 void policy_expand_private(smartlist_t **policy);
@@ -37,11 +37,7 @@ addr_policy_t *addr_policy_get_canonical_entry(addr_policy_t *ent);
 int cmp_addr_policies(smartlist_t *a, smartlist_t *b);
 addr_policy_result_t compare_tor_addr_to_addr_policy(const tor_addr_t *addr,
                               uint16_t port, const smartlist_t *policy);
-addr_policy_result_t compare_addr_to_addr_policy(uint32_t addr,
-                              uint16_t port, const smartlist_t *policy);
 
-addr_policy_result_t compare_addr_to_node_policy(uint32_t addr,
-                              uint16_t port, const node_t *node);
 addr_policy_result_t compare_tor_addr_to_node_policy(const tor_addr_t *addr,
                               uint16_t port, const node_t *node);
 
diff --git a/src/or/relay.c b/src/or/relay.c
index cf53116..7c62080 100644
--- a/src/or/relay.c
+++ b/src/or/relay.c
@@ -704,7 +704,7 @@ connection_ap_process_end_not_open(
     relay_header_t *rh, cell_t *cell, origin_circuit_t *circ,
     edge_connection_t *conn, crypt_path_t *layer_hint)
 {
-  struct in_addr in;
+  tor_addr_t addr;
   node_t *exitrouter;
   int reason = *(cell->payload+RELAY_HEADER_SIZE);
   int control_reason = reason | END_STREAM_REASON_FLAG_REMOTE;
@@ -722,33 +722,34 @@ connection_ap_process_end_not_open(
     switch (reason) {
       case END_STREAM_REASON_EXITPOLICY:
         if (rh->length >= 5) {
-          uint32_t addr = ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE+1));
+          uint32_t a = get_uint32(cell->payload+RELAY_HEADER_SIZE+5);
           int ttl;
-          if (!addr) {
+          if (!a) {
             log_info(LD_APP,"Address '%s' resolved to 0.0.0.0. Closing,",
                      safe_str(conn->socks_request->address));
             connection_mark_unattached_ap(conn, END_STREAM_REASON_TORPROTOCOL);
             return 0;
           }
+          tor_addr_from_ipv4n(&addr, ntohl(a));
           if (rh->length >= 9)
             ttl = (int)ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE+5));
           else
             ttl = -1;
 
           if (get_options()->ClientDNSRejectInternalAddresses &&
-              is_internal_IP(addr, 0)) {
+              tor_addr_is_internal(&addr, 0)) {
             log_info(LD_APP,"Address '%s' resolved to internal. Closing,",
                      safe_str(conn->socks_request->address));
             connection_mark_unattached_ap(conn, END_STREAM_REASON_TORPROTOCOL);
             return 0;
           }
-          client_dns_set_addressmap(conn->socks_request->address, addr,
+          client_dns_set_addressmap(conn->socks_request->address, &addr,
                                     conn->chosen_exit_name, ttl);
         }
         /* check if he *ought* to have allowed it */
         if (exitrouter &&
             (rh->length < 5 ||
-             (tor_inet_aton(conn->socks_request->address, &in) &&
+             (tor_inet_pton(AF_UNSPEC, conn->socks_request->address, &addr) &&
               !conn->chosen_exit_name))) {
           log_info(LD_APP,
                  "Exitrouter '%s' seems to be more restrictive than its exit "
@@ -848,13 +849,10 @@ connection_ap_process_end_not_open(
  * dotted-quad representation of <b>new_addr</b> (given in host order),
  * and send an appropriate REMAP event. */
 static void
-remap_event_helper(edge_connection_t *conn, uint32_t new_addr)
+remap_event_helper(edge_connection_t *conn, tor_addr_t *new_addr)
 {
-  struct in_addr in;
-
-  in.s_addr = htonl(new_addr);
-  tor_inet_ntoa(&in, conn->socks_request->address,
-                sizeof(conn->socks_request->address));
+  tor_addr_to_str(new_addr, conn->socks_request->address,
+                sizeof(conn->socks_request->address),1);
   control_event_stream_status(conn, STREAM_EVENT_REMAP,
                               REMAP_STREAM_SOURCE_EXIT);
 }
@@ -871,6 +869,7 @@ connection_edge_process_relay_cell_not_open(
     relay_header_t *rh, cell_t *cell, circuit_t *circ,
     edge_connection_t *conn, crypt_path_t *layer_hint)
 {
+  tor_addr_t addr;
   if (rh->command == RELAY_COMMAND_END) {
     if (CIRCUIT_IS_ORIGIN(circ) && conn->_base.type == CONN_TYPE_AP) {
       return connection_ap_process_end_not_open(rh, cell,
@@ -898,12 +897,13 @@ connection_edge_process_relay_cell_not_open(
     log_info(LD_APP,"'connected' received after %d seconds.",
              (int)(time(NULL) - conn->_base.timestamp_lastread));
     if (rh->length >= 4) {
-      uint32_t addr = ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE));
+      uint32_t a = get_uint32(cell->payload+RELAY_HEADER_SIZE);
       int ttl;
-      if (!addr || (get_options()->ClientDNSRejectInternalAddresses &&
-                    is_internal_IP(addr, 0))) {
+      tor_addr_from_ipv4n(&addr, a);
+      if (!a || (get_options()->ClientDNSRejectInternalAddresses &&
+                    tor_addr_is_internal(&addr, 0))) {
         log_info(LD_APP, "...but it claims the IP address was %s. Closing.",
-                 fmt_addr32(addr));
+                 fmt_addr(&addr));
         connection_edge_end(conn, END_STREAM_REASON_TORPROTOCOL);
         connection_mark_unattached_ap(conn, END_STREAM_REASON_TORPROTOCOL);
         return 0;
@@ -912,10 +912,10 @@ connection_edge_process_relay_cell_not_open(
         ttl = (int)ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE+4));
       else
         ttl = -1;
-      client_dns_set_addressmap(conn->socks_request->address, addr,
+      client_dns_set_addressmap(conn->socks_request->address, &addr,
                                 conn->chosen_exit_name, ttl);
 
-      remap_event_helper(conn, addr);
+      remap_event_helper(conn, &addr);
     }
     circuit_log_path(LOG_INFO,LD_APP,TO_ORIGIN_CIRCUIT(circ));
     /* don't send a socks reply to transparent conns */
@@ -976,12 +976,16 @@ connection_edge_process_relay_cell_not_open(
                                   2+answer_len));
     else
       ttl = -1;
-    if (answer_type == RESOLVED_TYPE_IPV4 && answer_len == 4) {
-      uint32_t addr = ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE+2));
+    if (answer_type == RESOLVED_TYPE_IPV4 || answer_type == RESOLVED_TYPE_IPV6) {
+      if (answer_type == RESOLVED_TYPE_IPV4 && answer_len == 4) {
+        tor_addr_from_ipv4n(&addr, get_uint32(cell->payload+RELAY_HEADER_SIZE+2));
+      } else {
+        tor_addr_from_ipv6_bytes(&addr, (char *)cell->payload+RELAY_HEADER_SIZE+2);
+      }
       if (get_options()->ClientDNSRejectInternalAddresses &&
-          is_internal_IP(addr, 0)) {
+          tor_addr_is_internal(&addr, 0)) {
         log_info(LD_APP,"Got a resolve with answer %s. Rejecting.",
-                 fmt_addr32(addr));
+                 fmt_addr(&addr));
         connection_ap_handshake_socks_resolved(conn,
                                                RESOLVED_TYPE_ERROR_TRANSIENT,
                                                0, NULL, 0, TIME_MAX);
@@ -996,8 +1000,12 @@ connection_edge_process_relay_cell_not_open(
                    ttl,
                    -1);
     if (answer_type == RESOLVED_TYPE_IPV4 && answer_len == 4) {
-      uint32_t addr = ntohl(get_uint32(cell->payload+RELAY_HEADER_SIZE+2));
-      remap_event_helper(conn, addr);
+      tor_addr_from_ipv4n(&addr, get_uint32(cell->payload+RELAY_HEADER_SIZE+2));
+      remap_event_helper(conn, &addr);
+    }
+    else if (answer_type == RESOLVED_TYPE_IPV6 && answer_len == 16) {
+      tor_addr_from_ipv6_bytes(&addr, (char *)cell->payload+RELAY_HEADER_SIZE+2);
+      remap_event_helper(conn, &addr);
     }
     connection_mark_unattached_ap(conn,
                               END_STREAM_REASON_DONE |
diff --git a/src/or/rendservice.c b/src/or/rendservice.c
index 3d5c80c..425b725 100644
--- a/src/or/rendservice.c
+++ b/src/or/rendservice.c
@@ -1623,7 +1623,7 @@ directory_post_to_hs_dir(rend_service_descriptor_t *renddesc,
                                               strlen(desc->desc_str), 0);
       base32_encode(desc_id_base32, sizeof(desc_id_base32),
                     desc->desc_id, DIGEST_LEN);
-      hs_dir_ip = tor_dup_ip(hs_dir->addr);
+      hs_dir_ip = tor_dup_ip(&hs_dir->addr);
       log_info(LD_REND, "Sending publish request for v2 descriptor for "
                         "service '%s' with descriptor ID '%s' with validity "
                         "of %d seconds to hidden service directory '%s' on "
diff --git a/src/or/rephist.c b/src/or/rephist.c
index 1ab4171..8cd35e8 100644
--- a/src/or/rephist.c
+++ b/src/or/rephist.c
@@ -311,7 +311,7 @@ rep_hist_note_router_reachable(const char *id, const tor_addr_t *at_addr,
   tor_assert((!at_addr && !at_port) || (at_addr && at_port));
 
   addr_changed = at_addr &&
-    tor_addr_compare(at_addr, &hist->last_reached_addr, CMP_EXACT) != 0;
+    !tor_addr_eq(at_addr, &hist->last_reached_addr);
   port_changed = at_port && at_port != hist->last_reached_port;
 
   if (!started_tracking_stability)
diff --git a/src/or/router.c b/src/or/router.c
index e2791c1..0ef2d1c 100644
--- a/src/or/router.c
+++ b/src/or/router.c
@@ -852,7 +852,6 @@ consider_testing_reachability(int test_or, int test_dir)
 {
   const routerinfo_t *me = router_get_my_routerinfo();
   int orport_reachable = check_whether_orport_reachable();
-  tor_addr_t addr;
   or_options_t *options = get_options();
   if (!me)
     return;
@@ -887,13 +886,12 @@ consider_testing_reachability(int test_or, int test_dir)
     extend_info_free(ei);
   }
 
-  tor_addr_from_ipv4h(&addr, me->addr);
   if (test_dir && !check_whether_dirport_reachable() &&
       !connection_get_by_type_addr_port_purpose(
-                CONN_TYPE_DIR, &addr, me->dir_port,
+                CONN_TYPE_DIR, &me->addr, me->dir_port,
                 DIR_PURPOSE_FETCH_SERVERDESC)) {
     /* ask myself, via tor, for my server descriptor. */
-    directory_initiate_command(me->address, &addr,
+    directory_initiate_command(me->address, &me->addr,
                                me->or_port, me->dir_port,
                                0, /* does not matter */
                                0, me->cache_info.identity_digest,
@@ -1378,14 +1376,14 @@ router_get_my_extrainfo(void)
  * declaration verbatim rather than as digests. */
 static smartlist_t *warned_nonexistent_family = NULL;
 
-static int router_guess_address_from_dir_headers(uint32_t *guess);
+static int router_guess_address_from_dir_headers(tor_addr_t *guess);
 
 /** Make a current best guess at our address, either because
  * it's configured in torrc, or because we've learned it from
  * dirserver headers. Place the answer in *<b>addr</b> and return
  * 0 on success, else return -1 if we have no guess. */
 int
-router_pick_published_address(or_options_t *options, uint32_t *addr)
+router_pick_published_address(or_options_t *options, tor_addr_t *addr)
 {
   if (resolve_my_address(LOG_INFO, options, addr, NULL) < 0) {
     log_info(LD_CONFIG, "Could not determine our address locally. "
@@ -1396,7 +1394,7 @@ router_pick_published_address(or_options_t *options, uint32_t *addr)
       return -1;
     }
   }
-  log_info(LD_CONFIG,"Success: chose address '%s'.", fmt_addr32(*addr));
+  log_info(LD_CONFIG,"Success: chose address '%s'.", fmt_addr(addr));
   return 0;
 }
 
@@ -1409,7 +1407,7 @@ router_rebuild_descriptor(int force)
 {
   routerinfo_t *ri;
   extrainfo_t *ei;
-  uint32_t addr;
+  tor_addr_t addr;
   char platform[256];
   int hibernating = we_are_hibernating();
   or_options_t *options = get_options();
@@ -1427,9 +1425,9 @@ router_rebuild_descriptor(int force)
 
   ri = tor_malloc_zero(sizeof(routerinfo_t));
   ri->cache_info.routerlist_index = -1;
-  ri->address = tor_dup_ip(addr);
+  ri->address = tor_dup_ip(&addr);
   ri->nickname = tor_strdup(options->Nickname);
-  ri->addr = addr;
+  tor_addr_copy(&ri->addr, &addr);
   ri->or_port = router_get_advertised_or_port(options);
   ri->dir_port = router_get_advertised_dir_port(options);
   ri->cache_info.published_on = time(NULL);
@@ -1638,21 +1636,16 @@ check_descriptor_bandwidth_changed(time_t now)
 /** Note at log level severity that our best guess of address has changed from
  * <b>prev</b> to <b>cur</b>. */
 static void
-log_addr_has_changed(int severity, uint32_t prev, uint32_t cur,
+log_addr_has_changed(int severity, tor_addr_t *prev, tor_addr_t *cur,
                      const char *source)
 {
   char addrbuf_prev[INET_NTOA_BUF_LEN];
   char addrbuf_cur[INET_NTOA_BUF_LEN];
-  struct in_addr in_prev;
-  struct in_addr in_cur;
-
-  in_prev.s_addr = htonl(prev);
-  tor_inet_ntoa(&in_prev, addrbuf_prev, sizeof(addrbuf_prev));
 
-  in_cur.s_addr = htonl(cur);
-  tor_inet_ntoa(&in_cur, addrbuf_cur, sizeof(addrbuf_cur));
+  tor_addr_to_str(prev, addrbuf_prev, sizeof(addrbuf_prev), 1);
+  tor_addr_to_str(cur, addrbuf_cur, sizeof(addrbuf_cur), 1);
 
-  if (prev)
+  if (tor_addr_is_null(prev))
     log_fn(severity, LD_GENERAL,
            "Our IP Address has changed from %s to %s; "
            "rebuilding descriptor (source: %s).",
@@ -1669,28 +1662,28 @@ log_addr_has_changed(int severity, uint32_t prev, uint32_t cur,
 void
 check_descriptor_ipaddress_changed(time_t now)
 {
-  uint32_t prev, cur;
+  tor_addr_t prev, cur;
   or_options_t *options = get_options();
   (void) now;
 
   if (!desc_routerinfo)
     return;
 
-  prev = desc_routerinfo->addr;
+  tor_addr_copy(&prev, &desc_routerinfo->addr);
   if (resolve_my_address(LOG_INFO, options, &cur, NULL) < 0) {
     log_info(LD_CONFIG,"options->Address didn't resolve into an IP.");
     return;
   }
 
-  if (prev != cur) {
-    log_addr_has_changed(LOG_NOTICE, prev, cur, "resolve");
+  if (!tor_addr_eq(&prev, &cur)) {
+    log_addr_has_changed(LOG_NOTICE, &prev, &cur, "resolve");
     ip_address_changed(0);
   }
 }
 
 /** The most recently guessed value of our IP address, based on directory
  * headers. */
-static uint32_t last_guessed_ip = 0;
+static tor_addr_t last_guessed_ip;
 
 /** A directory server <b>d_conn</b> told us our IP address is
  * <b>suggestion</b>.
@@ -1700,38 +1693,36 @@ void
 router_new_address_suggestion(const char *suggestion,
                               const dir_connection_t *d_conn)
 {
-  uint32_t addr, cur = 0;
-  struct in_addr in;
+  tor_addr_t addr, cur;
   or_options_t *options = get_options();
 
   /* first, learn what the IP address actually is */
-  if (!tor_inet_aton(suggestion, &in)) {
+  if (!tor_inet_pton(AF_UNSPEC, suggestion, &addr)) {
     log_debug(LD_DIR, "Malformed X-Your-Address-Is header %s. Ignoring.",
               escaped(suggestion));
     return;
   }
-  addr = ntohl(in.s_addr);
 
   log_debug(LD_DIR, "Got X-Your-Address-Is: %s.", suggestion);
 
   if (!server_mode(options)) {
-    last_guessed_ip = addr; /* store it in case we need it later */
+    tor_addr_copy(&last_guessed_ip, &addr); /* store it in case we need it later */
     return;
   }
 
   if (resolve_my_address(LOG_INFO, options, &cur, NULL) >= 0) {
     /* We're all set -- we already know our address. Great. */
-    last_guessed_ip = cur; /* store it in case we need it later */
+    tor_addr_copy(&last_guessed_ip, &cur); /* store it in case we need it later */
     return;
   }
-  if (is_internal_IP(addr, 0)) {
+  if (tor_addr_is_internal(&addr, 0)) {
     /* Don't believe anybody who says our IP is, say, 127.0.0.1. */
     return;
   }
-  if (tor_addr_eq_ipv4h(&d_conn->_base.addr, addr)) {
+  if (tor_addr_eq(&d_conn->_base.addr, &addr)) {
     /* Don't believe anybody who says our IP is their IP. */
     log_debug(LD_DIR, "A directory server told us our IP address is %s, "
-              "but he's just reporting his own IP address. Ignoring.",
+              "but it is just reporting their own IP address. Ignoring.",
               suggestion);
     return;
   }
@@ -1739,14 +1730,13 @@ router_new_address_suggestion(const char *suggestion,
   /* Okay.  We can't resolve our own address, and X-Your-Address-Is is giving
    * us an answer different from what we had the last time we managed to
    * resolve it. */
-  if (last_guessed_ip != addr) {
+  if (!tor_addr_eq(&last_guessed_ip, &addr)) {
     control_event_server_status(LOG_NOTICE,
                                 "EXTERNAL_ADDRESS ADDRESS=%s METHOD=DIRSERV",
                                 suggestion);
-    log_addr_has_changed(LOG_NOTICE, last_guessed_ip, addr,
-                         d_conn->_base.address);
+    log_addr_has_changed(LOG_NOTICE, &last_guessed_ip, &addr, d_conn->_base.address);
     ip_address_changed(0);
-    last_guessed_ip = addr; /* router_rebuild_descriptor() will fetch it */
+    tor_addr_copy(&last_guessed_ip, &addr); /* router_rebuild_descriptor() will fetch it */
   }
 }
 
@@ -1755,10 +1745,10 @@ router_new_address_suggestion(const char *suggestion,
  * about our address based on directory headers, answer it and return
  * 0; else return -1. */
 static int
-router_guess_address_from_dir_headers(uint32_t *guess)
+router_guess_address_from_dir_headers(tor_addr_t *guess)
 {
-  if (last_guessed_ip) {
-    *guess = last_guessed_ip;
+  if (tor_addr_is_null(&last_guessed_ip)) {
+    tor_addr_copy(guess, &last_guessed_ip);
     return 0;
   }
   return -1;
diff --git a/src/or/router.h b/src/or/router.h
index d126ac9..922407e 100644
--- a/src/or/router.h
+++ b/src/or/router.h
@@ -76,7 +76,7 @@ int router_digest_is_me(const char *digest);
 int router_extrainfo_digest_is_me(const char *digest);
 int router_is_me(const routerinfo_t *router);
 int router_fingerprint_is_me(const char *fp);
-int router_pick_published_address(or_options_t *options, uint32_t *addr);
+int router_pick_published_address(or_options_t *options, tor_addr_t *addr);
 int router_rebuild_descriptor(int force);
 int router_dump_router_to_string(char *s, size_t maxlen, routerinfo_t *router,
                                  crypto_pk_env_t *ident_key);
